//*****************************************
// Six IN-17 Clock2 Program ATmega64(64pin)
// CPU Clock:8MHz
//   UWlgɂ

//   q[Yf[^́@`FbŃurohdmv
//   @@@@@@@@@uannsryv́uBoot Flash size=4096 words Boot Address=$7000v
//   @@@@@@@@@uanckdudkv́uBrown-out detection at VCC=2.7Vv
//   @@@@@@@@@urtsQbjrdkv́uInt Rc Osc.8MHz,Start-up time:6CK+64msv
//
// File Name:six_in17_clock2.c
//@ pro_fifteen_in17_clock ̃vWFNgRs[ā@pr_six_in16_clock@ɂ킹B
//
//
//  2017/09/13 New TAB4 Taishi
//  2017/12/13 Ver 2.00 Taishi
//  2018/10/25 Modify for Fifteen IN-17 Clock Taishi
//  2019/12/30 Modify for fourteen IN-172 Clock Taishi
//  2020/09/17 Modify for six IN-16 clock Taishi
//  2022/08/23 Modify for pr_six_in17_clock2 Taishi
//*****************************************
#include	<avr/interrupt.h>
#include	<avr/io.h>


#include	"six_in17_clock2.h"
#include	"timer.h"
#include	"port_bit.h"
#include	"display.h"
#include	"ad_conv.h"
#include	"nixie.h"
#include	"rtc_ds3234.h"
#include	"set_rtc.h"
#include	"eep_dat.h"
#include	"uart.h"
#include	"infrared.h"
#include	"gps_clock.h"


static	unsigned char	run=0;
static	int				bef1_ad_ave=0;
static	unsigned char	renzoku[16]      ={1,7,2,8,0,6,3,9,4,5,15,15,15,15,15,15};		// ̑w̑w
static	unsigned char	gyaku_renzoku[16]={5,4,9,3,6,0,8,2,7,1,15,15,15,15,15,15};		// ̑w牺̑w

//***************************
// crQ̓_ŁiTOrj
//  crQ_ł
//   F
//  crQ͏ŏI
//  _Ŏ͓_TOrATOr
//  Ȃ̂łP̓_łɖPOOr|
//  ̃[`͂crQTOro߂ďI
//***************************
void	blink_ds2_50ms(unsigned char n)
{
	unsigned char	uc;

	for(uc=0;uc < n;uc++){
		led_ds2_on();			// LED(DS3) ON
		delay_ms(50);			// 500mS Delay
		led_ds2_off();			// LED(DS3) OFF
		delay_ms(50);			// 500mS Delay
	}
}
//***************************
// crQ̓_
//  crQ_ł
//   F
//  crQ͏ŏI
//  _Ŏ͓_TOOrATOOr
//  Ȃ̂łP̓_łɖPb|
//  ̃[`͂crQTOOro߂ďI
//***************************
void	blink_ds2(unsigned char n)
{
	unsigned char	uc;

	for(uc=0;uc < n;uc++){
		led_ds2_on();			// LED(DS2) ON
		delay_ms(500);			// 500mS Delay
		led_ds2_off();			// LED(DS2) OFF
		delay_ms(500);			// 500mS Delay
	}
}
//***************************
// crR̓_ŁiTOrj
//  crR_ł
//   F
//  crR͏ŏI
//  _Ŏ͓_TOrATOr
//  Ȃ̂łP̓_łɖPOOr|
//  ̃[`͂crRTOro߂ďI
//***************************
void	blink_ds3_50ms(unsigned char n)
{
	unsigned char	uc;

	for(uc=0;uc < n;uc++){
		led_ds3_on();			// LED(DS3) ON
		delay_ms(50);			// 500mS Delay
		led_ds3_off();			// LED(DS3) OFF
		delay_ms(50);			// 500mS Delay
	}
}
//***************************
// crR̓_
//  crR_ł
//   F
//  crR͏ŏI
//  _Ŏ͓_TOOrATOOr
//  Ȃ̂łP̓_łɖb|
//  ̃[`͂crRTOOro߂ďI
//***************************
void	blink_ds3(unsigned char n)
{
	unsigned char	uc;

	for(uc=0;uc < n;uc++){
		led_ds3_on();			// LED(DS3) ON
		delay_ms(500);			// 500mS Delay
		led_ds3_off();			// LED(DS3) OFF
		delay_ms(500);			// 500mS Delay
	}
}
//***************************
// crQƂcrR̓_
//  crQƂcrR𓯂^C~Oœ_ł
//   F
//  crQƂcrR͏ŏI
//  _Ŏ͓_TOOrATOOr
//  Ȃ̂łP̓_łɖPb|
//  ̃[`͂crQƂcrRTOOro߂ďI
//***************************
void	blink_ds23(unsigned char n)
{
	unsigned char	uc;

	for(uc=0;uc < n;uc++){
		led_ds2_on();			// LED(DS2) ON
		led_ds3_on();			// LED(DS3) ON
		delay_ms(500);			// 500mS Delay
		led_ds2_off();			// LED(DS2) OFF
		led_ds3_off();			// LED(DS3) OFF
		delay_ms(500);			// 500mS Delay
	}
}
//***************************
// crQƂcrŘݓ_
//  crQƂcrR݂ɓ_ł
//  crQ_ƂcrR͏A
//  crR_ƂcrQ͏
//   F
//  ŏ͂crQ_AcrR
//  crQƂcrRŏI
//  _Ŏ͓_TOOrATOOr
//  Ȃ̂łP̓_łɖPb|
//  ̃[`͂crRシɏI
//***************************
void	blink_toggle_ds23(unsigned char n)
{
	unsigned char	uc;

	for(uc=0;uc < n;uc++){
		led_ds2_on();			// LED(DS2) ON
		led_ds3_off();			// LED(DS3) OFF
		delay_ms(500);			// 500mS Delay
		led_ds2_off();			// LED(DS2) OFF
		led_ds3_on();			// LED(DS3) ON
		delay_ms(500);			// 500mS Delay
	}
	led_ds3_off();			// LED(DS3) OFF
}
//***************************
// `FbNiX^eBbN\js
//  kdcicrQjRx_łAŏʂɂO\
//  R_Ă鎞 XCb`閈ɂnm^neeJԂA
//  e̐\Ă鎞 XCb`閈ɂO`XAc|kAc|qԂɕ\
//  XCb` \錅ړB ԍ珇ԂɉEiʌjֈړAԉE͈̎ԍɖ߂
//***************************
void	check_static(void)
{
	unsigned short	us;
	unsigned char	kazu = 0;
	unsigned char	keta = 0;

	blink_ds2(3);									// crQ̓_

	led_ds2_on();									// LED(DS2) ON
	wait_sw_off();									// XCb`@܂ŉiv[v
	led_ds2_off();									// LED(DS2) OFF

	get_sw();

	sei();											// 荞݉
	delay_ms(10);									// 100mS Delay
	get_sw();
	delay_ms(10);									// 100mS Delay
	get_sw();
	delay_ms(10);									// 100mS Delay

	bef1_ad_ave = 0;
	keta = 0;
	kazu = 0;
	disp_static_nixie_number(keta, kazu);			// 
	led_ds2_off();									// LED(DS2) OFF
	led_ds3_off();									// LED(DS3) OFF
	tim_10ms_ad = 0;

	for(;;){
		us = get_action_sw();									// XCb`Ԃ
		us &= SW_MASK;											// XCb`ɂ

		if((us == SW2_OFF_SHORT)||(us == SW2_OFF_LONG)){		// XCb`NbNꂽ(select switch)
			kazu++;
			if(9 < kazu){
				kazu = 0;
			}

			if(keta <= KETA_MAX){
				disp_static_dotl_on_off(0);						// Dot-L : OFF
				disp_static_dotr_on_off(0);						// Dot-R : OFF
				disp_static_nixie_number(keta, kazu);			// 
			}

			led_ds3_on();										// LED(DS3) ON
			delay_ms(200);										// 200mS Delay
			led_ds3_off();										// LED(DS3) OFF
		}

		if((us == SW1_OFF_SHORT)||(us == SW1_OFF_LONG)){		// XCb`NbNꂽ(set switch)
			keta++;

			if((KETA_MAX+2+7) < keta){
				keta = 0;
			}
			if(KETA_MAX+2 < keta){
				disp_static_nixie_number(keta, 15);				//  OFF
				disp_static_dotl_on_off(0);						// Dot-L : OFF
				disp_static_dotr_on_off(0);						// Dot-R : OFF
				disp_static_day_of_week(keta - KETA_MAX - 3);	// j\
			}else if(KETA_MAX+1 == keta){
				disp_static_nixie_number(keta, 15);				//  OFF
				disp_static_day_of_week(7);						// j OFF
				disp_static_dotr_on_off(0);						// Dot-R : OFF
				disp_static_dotl_on_off(1);						// Dot-L : ON
			}else if(KETA_MAX+2 == keta){
				disp_static_nixie_number(keta, 15);				//  OFF
				disp_static_day_of_week(7);						// j OFF
				disp_static_dotl_on_off(0);						// Dot-L : OFF
				disp_static_dotr_on_off(1);						// Dot-R : ON
			}else{
				disp_static_day_of_week(7);						// j OFF
				disp_static_dotl_on_off(0);						// Dot-L : OFF
				disp_static_dotr_on_off(0);						// Dot-R : OFF
				disp_static_nixie_number(keta, kazu);			// 
			}

			led_ds2_on();										// LED(DS2) ON
			delay_ms(200);										// 200mS Delay
			led_ds2_off();										// LED(DS2) OFF
		}
	}

}
//***************************
// `FbNi_Ci~bN\js
//  kdcicrRjRx_ł
//  XCb`ėꂽ eO`XAĕ\iPbԊuŕ\ωj
//    ԉĚ̎̓R\
//***************************
void	check_dynamic(void)
{
	unsigned short	us;
	unsigned char	old_run = 0;
	unsigned char	kazu = 0;
	unsigned char	keta = 0;
	unsigned char	old_keta = 1;
	unsigned char	pause = 0;

	blink_ds3(3);									// crR̓_

	led_ds3_on();									// LED(DS3) ON
	delay_ms(500);									// 500mS Delay
	wait_sw_off();									// XCb`@܂ŉiv[v
	led_ds3_off();									// LED(DS3) OFF

	get_sw();

	tim_10ms_blink = 0;								// uNp^C}[𗬗p
	old_run = run;
	sei();											// 荞݉
	delay_ms(10);									// 100mS Delay
	get_sw();
	delay_ms(10);									// 100mS Delay
	get_sw();
	delay_ms(10);									// 100mS Delay


	bef1_ad_ave = 0;
	led_ds2_off();									// LED(DS2) OFF
	tim_10ms_ad = 0;
	disp_dynamic_nixie_clear();						// Nixie \SA
	dynamic_nixie_active(1);						// _Ci~bN\Jn
	disp_dynamic_dotl_on_off(0);					// Dot-L : OFF
	disp_dynamic_dotr_on_off(0);					// Dot-R : OFF
	disp_dynamic_day_of_week(7);					// j\

	for(;;){
		us = get_action_sw();									// XCb`Ԃ
		us &= SW_MASK;											// XCb`ɂ

		if(us == SW2_OFF_SHORT){								// XCb`Zėꂽ(select switch)
			pause ^= 1;											// ړ\𒆒f or Jn
		}

		if(tim_10ms_blink == 0){
			tim_10ms_blink = 100;								// 1000mS Ԋu
			if(pause == 0){
				if((KETA_MAX+2) < keta){
					disp_dynamic_dotl_on_off(0);					// hbg@
					disp_dynamic_dotr_on_off(0);					// Dot-R : OFF
					disp_dynamic_day_of_week(keta-(KETA_MAX+3));	// j\
					kazu = 0;										// Oɖ߂
					keta++;

				}else if((KETA_MAX+2) == keta){
					disp_dynamic_dotl_on_off(0);					// Dot-L : OFF
					disp_dynamic_dotr_on_off(1);					// Dot-R : ON
					kazu = 0;										// Oɖ߂
					keta++;

				}else if((KETA_MAX+1) == keta){
					disp_dynamic_nixie_number(old_keta, 15);		// 
					disp_dynamic_dotl_on_off(1);					// Dot-L : ON
					kazu = 0;										// Oɖ߂
					keta++;

				}else{
					if(old_keta != keta){							// ς
						disp_dynamic_nixie_number(old_keta, 15);	// Ǒ̐
						old_keta = keta;
					}

					disp_dynamic_dotl_on_off(0);					// Dot-L : OFF
					disp_dynamic_dotr_on_off(0);					// Dot-R : OFF
					disp_dynamic_day_of_week(7);					// j\
					disp_dynamic_nixie_number(keta, kazu);			// 

					kazu++;
					if(9 < kazu){									// \XȏɂȂ
						kazu = 0;									// Oɖ߂
						keta++;
					}

				}
				if((KETA_MAX+7+2) < keta){
					keta = 0;										// \߂
				}
			}
		}
	}

}

//***************************
// ␳aorUOOvZ
// uc : ^C}[P̃JE^[lłWlgȂ΂VWPR̔
// ␳lVWPRaorQUOO
//***************************
unsigned short calc_bps600(unsigned short us)
{
	unsigned short r;
	unsigned long ul;

	ul = us;
	ul *= (unsigned long)(BPS_600);
	ul /= (unsigned long)7813;
	r = (unsigned short)ul;

	return(r);

}
//***************************
// aorUOO̒l`FbN
//  kdcSx_ł
//  XCb`ėꂽ 
//@aorUOO̒lŉʂRɕ\BiWlg҂ȂWRRj
//@qsb̂PbM̃^C~OŃ^C}[P̒lƂaorUOO̒lXV
//  rdsXCb`Zꂽ@݂̂aorUOO̒lɏ݈Ȍケ̒lg
//***************************
//void	check_bps600(void)
//{
//	unsigned short	us;
//	unsigned short	t1_count = 7813;
//	unsigned short	bps600 = 833;
//	unsigned char	old_rtc_1s_flg=0xff;
//
//	bps600 = gBPS1_600;
//
//	led_ds2_on();									// LED(DS2) ON
//	delay_ms(500);									// 500mS Delay
//	led_ds2_off();									// LED(DS2) OFF
//	delay_ms(500);									// 500mS Delay
//	led_ds2_on();									// LED(DS2) ON
//	wait_sw_off();									// XCb`@܂ŉiv[v
//	led_ds2_off();									// LED(DS2) OFF
//	delay_ms(500);									// 500mS Delay
//	led_ds2_on();									// LED(DS2) ON
//	wait_sw_off();									// XCb`@܂ŉiv[v
//	led_ds2_off();									// LED(DS2) OFF
//	delay_ms(500);									// 500mS Delay
//	led_ds2_on();									// LED(DS2) ON
//	wait_sw_off();									// XCb`@܂ŉiv[v
//	led_ds2_off();									// LED(DS2) OFF
//
//	get_sw();
//
//	timer1_init();									// Timer1 Initial
//	tim_10ms_blink = 0;								// uNp^C}[𗬗p
//	sei();											// 荞݉
//	delay_ms(10);									// 100mS Delay
//	get_sw();
//	delay_ms(10);									// 100mS Delay
//	get_sw();
//	delay_ms(10);									// 100mS Delay
//
//	bef1_ad_ave = 0;
//	led_ds2_off();									// LED(DS2) OFF
//	tim_10ms_ad = 0;
//	disp_dynamic_nixie_clear();						// Nixie \SAR
//	disp_nixie_4binary(8,bps600);					// S\iXXXX܂Łj
//	dynamic_nixie_active(1);						// _Ci~bN\Jn
//	delay_ms(1000);									// 1S Delay
//
//	// ŏ̈͒l肵Ȃ̂ŃX[
//	for(;;){
//		if(rtc_1s_flg != old_rtc_1s_flg){						// qsbĂ鎞̂Pboߗp
//			TCNT1 = 0;											// sbmsP@NA
//			old_rtc_1s_flg = rtc_1s_flg;
//			break;
//		}
//	}
//	for(;;){
//		us = get_action_sw();									// XCb`Ԃ
//		us &= SW_MASK;											// XCb`ɂ
//
//		if(us == SW1_OFF_SHORT){								// XCb`Zėꂽ(set switch)
//			write_eep_bps_600(bps600);							//@ddoqnl BPS_600 
//		}
//
//		if(rtc_1s_flg != old_rtc_1s_flg){						// qsbĂ鎞̂Pboߗp
//			t1_count = TCNT1;									// sbmsPǂݏo
//			TCNT1 = 0;											// sbmsP@NA
//			old_rtc_1s_flg = rtc_1s_flg;
//			disp_nixie_4binary(0,t1_count);						// S\iXXXX܂Łj
//			bps600 = calc_bps600(t1_count);						// ␳aorUOOvZ
//			disp_nixie_4binary(8,bps600);						// S\iXXXX܂Łj
//		}
//	}
//
//}

//***************************
// Aj[V\
//@ODPbɌĂ΂
// 
//@FP̂
// ߂l
//@OAj[Vr
//@PAj[VI
//***************************
unsigned char	disp_animation(unsigned char init)
{
	static	unsigned char	ani_keta = 0;		//  0--5
	static	unsigned char	ani_kazu = 0;		// l 0--9, Dot-L:10, Dot-R:11
	unsigned char			r = 0;
	unsigned char			kazu_max = 9;

	if (init == 1){
		ani_keta = 0;
		ani_kazu = 0;
	}else{
		if(ani_kazu == 0){
			disp_dynamic_nixie_clear();						// Nixie \S
			ani_kazu = 0;
		}

		if((KETA_MAX) < ani_keta){							// hbg
			if((KETA_MAX+2) == ani_keta){					// Ehbg
				disp_dynamic_dotl_on_off(0);				// Dot-L : OFF
				disp_dynamic_day_of_week(7);				// j\ : off
				disp_dynamic_dotr_on_off(1);				// Dot-R : ON
			}else{											// hbg
				disp_dynamic_dotr_on_off(0);				// Dot-R : OFF
				disp_dynamic_dotl_on_off(1);				// Dot-L : ON
				disp_dynamic_day_of_week(ani_keta);			// j\
			}
			ani_kazu = kazu_max;							// XɂiŁ{P̂Ł@OɂȂj
		}else{												// jLV[ǁij
			if((ani_keta & 1) == 0){									// 
				disp_dynamic_nixie_number(ani_keta, renzoku[ani_kazu]);
			}else{														// E
				disp_dynamic_nixie_number(ani_keta, gyaku_renzoku[ani_kazu]);
			}
			disp_dynamic_day_of_week(ani_keta);				// j\
			disp_dynamic_dotl_on_off(0);					// Dot-L : OFF
			disp_dynamic_dotr_on_off(0);					// Dot-R : OFF
		}

		ani_kazu++;
		if(kazu_max < ani_kazu){
			ani_kazu = 0;
			ani_keta++;										// ̌
			if((KETA_MAX+2) < ani_keta){
				ani_keta = 0;
				r = 1;
			}
		}
	}

	return(r);
}

//***************************
// ԊORf[^XCb`f[^ɕϊ
//***************************
unsigned short	trans_if_to_sw(unsigned char if_data)
{
	unsigned short	us = 0;
	static unsigned short	sw_stat = 0;

	switch(if_data){
	 case IND1_ON_NOW:			// set n߂
		us = SW1_ON_NOW;
		sw_stat |= SW1_ON;
		break;
	 case IND1_ON_CONTINUE:		// set A
		us = SW1_ON_CONTINUE;
		break;
	 case IND1_OFF_SHORT:		// set Zė
		us = SW1_OFF_SHORT;
		sw_stat &= ~(SW1_ON);
		break;
	 case IND1_OFF_LONG:		// set ė
		us = SW1_OFF_LONG;
		sw_stat &= ~(SW1_ON);
		break;
	 case IND2_ON_NOW:			// select n߂
		us = SW2_ON_NOW;
		sw_stat |= SW2_ON;
		break;
	 case IND2_ON_CONTINUE:		// select A
		us = SW2_ON_CONTINUE;
		break;
	 case IND2_OFF_SHORT:		// select Zė
		us = SW2_OFF_SHORT;
		sw_stat &= ~(SW2_ON);
		break;
	 case IND2_OFF_LONG:		// select ė
		us = SW2_OFF_LONG;
		sw_stat &= ~(SW2_ON);
		break;
	}

	us |= sw_stat;
	return(us);
}


//***************************
//  Up Main
//***************************
static	void	main_6_keta(void)
{
	unsigned short	check_path_valu;
	unsigned short	us;
	unsigned short	ad_ave;
	unsigned char	ucinf;
	unsigned char	disp_clock_mode=HMS;
	unsigned char	old_disp_clock_mode=HM;
	unsigned char	old_rtc_1s_flg=0xff;
	unsigned char	old_RTC_sec = 0xff;
	unsigned char	old_RTC_min = 0xff;
	unsigned char	old_RTC_hou = 0xff;
	unsigned char	old_RTC_mon = 0xff;
	unsigned char	old_RTC_day = 0xff;
	unsigned char	old_RTC_year = 0xff;
	unsigned char	dark = 0;						// 0: 邢  1:Â

	sei();											// 荞݉

	bef1_ad_ave = 0;

	disp_nixie_4binary(2,VER_DATA);					// o[WS\iXXXX܂Łj
	if(VER_DATA/1000 == 0){
		disp_dynamic_nixie_number(2, 15);			// o[Wŏʌ  
	}

	tim_10ms_nixie = 100;
	dynamic_nixie_active(1);						// _Ci~bN\Jn

	disp_dynamic_dotl_on_off(0);					// hbg@
	disp_dynamic_dotr_on_off(1);					// Ehbg@_

	delay_ms(2000);									// 2000mS Delay


	disp_nixie_4binary(2,gBPS1_600);				// aorUOOS\iXXXX܂Łj
	disp_dynamic_dotl_on_off(0);					// hbg@
	disp_dynamic_dotr_on_off(0);					// Ehbg@

	delay_ms(2000);									// 2000mS Delay


	disp_dynamic_nixie_number(0, 15);
	disp_dynamic_nixie_number(1, 15);
	disp_dynamic_nixie_number(2, 15);
	disp_dynamic_nixie_number(3, 15);
	disp_dynamic_nixie_number(4, 15);
	disp_dynamic_nixie_number(5, gGPS_active);		// for̗L

	delay_ms(2000);									// 2000mS Delay


	led_ds2_off();									// LED(DS2) OFF
	led_ds3_off();									// LED(DS3) OFF

	while(1){
		us = get_action_sw();									// XCb`Ԃ
		us &= SW_MASK;											// XCb`ɂ
		ucinf = get_infrared_data();							// ԊORfqf[^
		if(us == 0){											// XCb`ĂȂ
			us = trans_if_to_sw(ucinf);							// ԊORf[^XCb`f[^ɕϊ
		}

		if(us == SW1_OFF_LONG){									// ꂽ(set switch)
			proc_no_key_timeup(1);								// L[͂L
			disp_clock_mode = SET;
			proc_set_rtc();										// v킹
			disp_clock_mode = HMS;
			old_RTC_year = 0xff;
			old_RTC_mon = 0xff;
			old_RTC_day = 0xff;
			old_RTC_hou = 0xff;
			old_RTC_min = 0xff;
			old_RTC_sec = 0xff;
			old_rtc_1s_flg = (rtc_1s_flg - 1);
		}else if(us == SW2_OFF_SHORT){							// Zꂽ(select switch)
			proc_no_key_timeup(1);								// L[͂L
			switch(disp_clock_mode){							// 샂[hύX
			 case HMS:
				disp_clock_mode = YMD;
				old_RTC_year = 0xff;
				old_RTC_mon = 0xff;
				old_RTC_day = 0xff;
				old_RTC_hou = 0xff;
				old_RTC_min = 0xff;
				old_RTC_sec = 0xff;
				break;
			 case YMD:
				disp_clock_mode = TEMPER;
				old_RTC_year = 0xff;
				old_RTC_mon = 0xff;
				old_RTC_day = 0xff;
				old_RTC_hou = 0xff;
				old_RTC_min = 0xff;
				old_RTC_sec = 0xff;
				break;
			 case TEMPER:
				disp_clock_mode = CDS;						// b[hɕύX
				old_RTC_year = 0xff;
				old_RTC_mon = 0xff;
				old_RTC_day = 0xff;
				old_RTC_hou = 0xff;
				old_RTC_min = 0xff;
				old_RTC_sec = 0xff;
				break;
			case CDS:
				disp_clock_mode = HMS;
				old_RTC_year = 0xff;
				old_RTC_mon = 0xff;
				old_RTC_day = 0xff;
				old_RTC_hou = 0xff;
				old_RTC_min = 0xff;
				old_RTC_sec = 0xff;
				break;
			 default:
				disp_clock_mode = HMS;
				old_RTC_year = 0xff;
				old_RTC_mon = 0xff;
				old_RTC_day = 0xff;
				old_RTC_hou = 0xff;
				old_RTC_min = 0xff;
				old_RTC_sec = 0xff;
				break;
			}
			old_rtc_1s_flg = (rtc_1s_flg - 1);					// ɕ\
		}else{
			if(rtc_1s_flg != old_rtc_1s_flg){					// qsbĂ鎞̂Pboߗp
#if	AD_NO == 7
				ad7_get_data();									// A/D 6 Get A/D data
				ad_ave = ad7_ave;
#else
 #if	AD_NO == 6
				ad6_get_data();									// A/D 6 Get A/D data
				ad_ave = ad6_ave;
 #else
  #if	AD_NO == 5
				ad5_get_data();									// A/D 5 Get A/D data
				ad_ave = ad5_ave;
  #else
				ad0_get_data();									// A/D 0 Get A/D data
				ad_ave = ad0_ave;
  #endif
 #endif
#endif
				old_rtc_1s_flg = rtc_1s_flg;
				rtc_read();										// RTC ǂݏo
				if(disp_clock_mode == HMS){						// Nb[h
					tim_10ms_nixie = 50;
					if(old_RTC_hou != gRTC_hou){				// ω
						disp_nixie_tow(0,gRTC_hou);				//  \
						old_RTC_hou = gRTC_hou;
						disp_dynamic_dotl_on_off(1);			// hbg@_
						disp_dynamic_dotr_on_off(1);			// Ehbg@_
						disp_dynamic_day_of_week(gRTC_wday - 1);// j\
					}
					if(old_RTC_min != gRTC_min){				// ω
						disp_nixie_tow(2,gRTC_min);				//  \
						old_RTC_min = gRTC_min;
					}
					if(old_RTC_sec != gRTC_sec){				// bω
						disp_nixie_tow(4,gRTC_sec);				// b \
						old_RTC_sec = gRTC_sec;
					}

					if((gRTC_min == 0)&&(gRTC_sec == 0)){		// ̎
						disp_clock_mode = ANIME;
						disp_animation(1);						// Aj[V
						old_disp_clock_mode = HMS;
					}

				}else if(disp_clock_mode == YMD){				// N[h
					tim_10ms_nixie = 50;
					if(old_RTC_year != gRTC_year){				// Nω
						disp_nixie_tow(0,gRTC_year);			// N \
						old_RTC_year = gRTC_year;
						disp_dynamic_day_of_week_complement(gRTC_wday - 1);	// j]\
					}
					if(old_RTC_mon != gRTC_mon){				// ω
						disp_nixie_tow(2,gRTC_mon);				//  \
						old_RTC_mon = gRTC_mon;
						disp_dynamic_day_of_week_complement(gRTC_wday - 1);	// j]\
					}
					if(old_RTC_day != gRTC_day){				// ω
						disp_nixie_tow(4,gRTC_day);				//  \
						old_RTC_day = gRTC_day;
						disp_dynamic_dotl_on_off(1);			// hbg@_
						disp_dynamic_dotr_on_off(1);			// Ehbg@_
						disp_dynamic_day_of_week_complement(gRTC_wday - 1);	// j]\
					}

					if((gRTC_min == 0)&&(gRTC_sec == 0)){		// ̎
						disp_clock_mode = ANIME;
						disp_animation(1);						// Aj[V
						old_disp_clock_mode = YMD;
					}

				}else if(disp_clock_mode == TEMPER){			// x\[h̎
					disp_dynamic_nixie_clear();					// Nixie \SADot
					temperature_read();							// xǂݏo
					disp_dynamic_nixie_number(0, 15);			// ŏʌ  
					disp_dynamic_nixie_number(1, 15);			// ŏʌ  
					disp_nixie_4binary(2,gTemperature);			// S\iXXXX܂Łj
					disp_dynamic_dotl_on_off(0);				// hbg@
					disp_dynamic_dotr_on_off(1);				// Ehbg@_
					disp_dynamic_day_of_week_all_off();			// jS

				}else if(disp_clock_mode == CDS){				// b[h̎
					disp_nixie_4binary(2,ad_ave);				// S\iXXXX܂Łj
					disp_dynamic_dotl_on_off(0);				// hbg@
					disp_dynamic_dotr_on_off(0);				// Ehbg@
					disp_dynamic_day_of_week_all_off();			// jS

				}else if(disp_clock_mode == Infr_Data){			// ԊOMf[^[h̎
					disp_dynamic_nixie_number(0, 15);			// ŏʌ  
					disp_dynamic_nixie_number(1, 15);			// ŏʌ  
					disp_nixie_4binary(2,Ginf_data);			// S\iXXXX܂Łj
				}

				// \x̒
				check_path_valu = change_path;
				check_path_valu *= 100;
				if(dark == 1){									// Â
					if (check_path_valu < 50){
						check_path_valu = 0;
					}else{
						check_path_valu -= 50;
					}
					if (ad_ave < check_path_valu){
						path_limit = 1;
						dark = 0;
					}
				}else{
					check_path_valu += 50;
					if (check_path_valu < ad_ave){
						path_limit = 4;
						dark = 1;
					}
				}
			}

			if (proc_no_key_timeup(0) == 0xff){						// ԃL[͂
				if((disp_clock_mode != HMS)&& (disp_clock_mode != ANIME)){	// \ŖŁAAjł
					disp_clock_mode = HMS;
					old_RTC_year = 0xff;
					old_RTC_mon = 0xff;
					old_RTC_day = 0xff;
					old_RTC_hou = 0xff;
					old_RTC_min = 0xff;
					old_RTC_sec = 0xff;
				}
			}

			if(tim_10ms_nixie == 0){							// TOO
				if(disp_clock_mode == ANIME){					// Aj[V̎
					tim_10ms_nixie = 20;						// POOr^C}[d|
					if(disp_animation(0) == 1){					// \
						disp_clock_mode = old_disp_clock_mode;
						old_RTC_year = 0xff;
						old_RTC_mon = 0xff;
						old_RTC_day = 0xff;
						old_RTC_hou = 0xff;
						old_RTC_min = 0xff;
						old_RTC_sec = 0xff;
					}
				}
			}
		}

		if((tim_10ms_infrared != 0)){							// ԊORfqԂ́@M̎
			led_ds3_on();										// LED(DS3) ON
		}else{
			led_ds3_off();										// LED(DS3) OFF
		}

		if((tim_10ms_uart != 0)){								// t`qsɐMiG[̗LAf[^̓eɂ͖֌Wj
			led_ds2_on();										// LED(DS2) ON
		}else{
			led_ds2_off();										// LED(DS2) OFF
		}

	}
}

//***************************
//  Main
//***************************
int	main(void)
{

	delay_ms(200);									// 200mS Delay

	init_nixe();									// Nixe\ 
	sw_init();										// XCb`֌W̏ݒ
	rtc_init();										// qsb̏ݒ
	led_ds_init();									// kdc֌W̏ݒ
	timer0_init();									// Timer0 Initial

	infrared_init();								// ԊORfq Initial

	uart1_tx_one(0x55);								// aor`FbNp UART1 TxD one char
	uart1_tx_one(0x55);								// aor`FbNp UART1 TxD one char
	uart1_tx_one(0xAA);								// aor`FbNp UART1 TxD one char
	uart1_tx_one(0xAA);								// aor`FbNp UART1 TxD one char

	gps_clock_init();								// forv Initial
	uart0_pause();									// UART0 ̎擾߂

#if	AD_NO == 7
	ad7_init();										// A/D 6 Initial
#else
 #if	AD_NO == 6
	ad6_init();										// A/D 6 Initial
 #else
  #if	AD_NO == 5
	ad5_init();										// A/D 5 Initial
  #else
	ad0_init();										// A/D 0 Initial
  #endif
 #endif
#endif

	path_limit = 1;									// \Ԉ 1--4 (1:bright -- 4:dark)
	change_path = read_eep_change_path();			// ddoqnl change_PATH ǂݍ
	gGPS_active = read_eep_gps_active();			// ddoqnl GPS_active ǂݍ

	blink_toggle_ds23(3);							// crQƂcrŘݓ_

//----  -------
//	{
//		unsigned char	uc;
//
//		for(uc = 0;uc < 10;uc++){
//			led_ds2_on();									// LED(DS2) ON
//			led_ds3_on();									// LED(DS3) ON
//			delay_ms(500);									// 500mS Delay
//			led_ds2_off();									// LED(DS2) OFF
//			led_ds3_off();									// LED(DS3) OFF
//			delay_ms(500);									// 500mS Delay
//			if((SW_PORT & SW2_ON_BIT) == 0){				// XCb`f[^Ă(select switch)
//				break;
//			}
//		}
//
//		for(;;){
//			if((SW_PORT & SW2_ON_BIT) == 0){				// XCb`f[^Ă(select switch)
//				led_ds3_on();								// LED(DS3) ON
//			}else{
//				led_ds3_off();								// LED(DS3) OFF
//			}
//
//			if((SW_PORT & SW1_ON_BIT) == 0){				// XCb`f[^Ă(set switch)
//				led_ds2_on();								// LED(DS2) ON
//			}else{
//				led_ds2_off();								// LED(DS2) OFF
//			}
//		}
//	}
//---------------

//----  -------
//	check_static();									// `FbNiX^eBbN\js
//	check_dynamic();								// `FbNi_Ci~bN\js
//---------------

	if((SW_PORT & SW2_ON_BIT) == 0){				// XCb`f[^Ă(select switch)
		if((SW_PORT & SW1_ON_BIT) == 0){			// XCb`f[^Ă(set switch)
			edit_eep_data();						// ddoqnlDATAҏW
		}
	}

	if((SW_PORT & SW2_ON_BIT) == 0){				// XCb`f[^Ă(select switch)
		check_dynamic();							// `FbNi_Ci~bN\js
	}

	if((SW_PORT & SW1_ON_BIT) == 0){				// XCb`f[^Ă(set switch)
		check_static();								// `FbNiX^eBbN\js
	}

	main_6_keta();									// Up Main

}
