//*****************************************
// Six IN-17 Clock2 Program ATmega64(64pin)
// CPU Clock:8MHz
//   UWlgɂ

//   q[Yf[^́@`FbŃurohdmv
//   @@@@@@@@@uannsryv́uBoot Flash size=4096 words Boot Address=$7000v
//   @@@@@@@@@uanckdudkv́uBrown-out detection at VCC=2.7Vv
//   @@@@@@@@@urtsQbjrdkv́uInt Rc Osc.8MHz,Start-up time:6CK+64msv
//
// File Name:timer.h
//  wb_[t@C
//
//  2017/09/13 New TAB4 Taishi
//  2017/12/13 Ver 2.00 Taishi
//  2018/10/25 Modify for Fifteen IN-17 Clock Taishi
//  2019/12/30 Modify for fourteen IN-172 Clock Taishi
//  2020/09/17 Modify for six IN-16 clock Taishi
//  2022/08/23 Modify for pr_six_in17_clock2 Taishi
//*****************************************

extern	void	delay_2us(unsigned char t);
extern	void	delay_ms(int tm);

// ************************ Timer 1 *************************
extern	void	timer1_init(void);
extern	void	timer1_close(void);

// ************************ Timer 0 *************************
// 1000uS(1mS) Interrupt
#define		COUNT_1MS_T0		250											// 1mS at 8MHz/32 = 250kHz(4uS)
#define		D_TCCR0B_1000		((0 << CS22) | (1 << CS21) | (1 << CS20))	// Timer Start (8MHz/32= 250kHz, 4uS)

// 500uS Interrupt
#define		COUNT_05MS_T0		125											// 0.5mS at 8MHz/32 = 250kHz(4uS)
#define		D_TCCR0B_500		((0 << CS22) | (1 << CS21) | (1 << CS20))	// Timer Start (8MHz/32= 250kHz, 4uS)

// 250uS Interrupt
#define		COUNT_025MS_T0		250											// 0.25mS at 8MHz/8 = 1000kHz(1uS)
#define		D_TCCR0B_250		((0 << CS22) | (1 << CS21) | (0 << CS20))	// Timer Start (8MHz/8= 1000kHz, 1uS)

// 200uS Interrupt
#define		COUNT_02MS_T0		200											// 0.25mS at 8MHz/8 = 1000kHz(1uS)
#define		D_TCCR0B_200		((0 << CS22) | (1 << CS21) | (0 << CS20))	// Timer Start (8MHz/8= 1000kHz, 1uS)

// 100uS Interrupt
#define		COUNT_01MS_T0		100											// 0.1mS at 8MHz/8 = 1000kHz(1uS)
#define		D_TCCR0B_100		((0 << CS22) | (1 << CS21) | (0 << CS20))	// Timer Start (8MHz/8= 1000kHz, 1uS)

extern	void			timer0_init(void);
extern	void			timer0_close(void);



// ****************** Timer 2 **** ATmega64 *****************
// 2000uS(2mS) Interrupt
#define		COUNT_2MS_T2		250											// 2mS at 8MHz/64 = 125kHz(8uS)
#define		D_TCCR2B_2000		((0 << CS22) | (1 << CS21) | (1 << CS20))	// Timer Start (8MHz/64= 125kHz, 8uS)

// 1000uS(1mS) Interrupt
#define		COUNT_1MS_T2		125											// 1mS at 8MHz/64 = 125kHz(8uS)
#define		D_TCCR2B_1000		((0 << CS22) | (1 << CS21) | (1 << CS20))	// Timer Start (8MHz/64= 125kHz, 8uS)

// 250uS Interrupt
#define		COUNT_025MS_T2		250											// 0.25mS at 8MHz/8 = 1000kHz(1uS)
#define		D_TCCR2B_250		((0 << CS22) | (1 << CS21) | (0 << CS20))	// Timer Start (8MHz/8= 1000kHz, 1uS)

// 200uS Interrupt
#define		COUNT_02MS_T2		200											// 0.25mS at 8MHz/8 = 1000kHz(1uS)
#define		D_TCCR2B_200		((0 << CS22) | (1 << CS21) | (0 << CS20))	// Timer Start (8MHz/8= 1000kHz, 1uS)

// 100uS Interrupt
#define		COUNT_01MS_T2		100											// 0.1mS at 8MHz/8 = 1000kHz(1uS)
#define		D_TCCR2B_100		((0 << CS22) | (1 << CS21) | (0 << CS20))	// Timer Start (8MHz/8= 1000kHz, 1uS)

extern	void			timer2_init(void);
extern	void			timer2_close(void);


// ******************** Timer 0 & Timer 2 ********************

#define		VAL_FOR_10MS_2000	5											// 2000uS(2mS) Interrupt ݎ10mSPʂl
#define		VAL_FOR_10MS_1000	10											// 1000uS(1mS) Interrupt ݎ10mSPʂl
#define		VAL_FOR_10MS_500	20											//  500uS(1mS) Interrupt ݎ10mSPʂl
#define		VAL_FOR_10MS_250	40											//  250uS(1mS) Interrupt ݎ10mSPʂl
#define		VAL_FOR_10MS_200	50											//  200uS(1mS) Interrupt ݎ10mSPʂl
#define		VAL_FOR_10MS_100	100											//  100uS(1mS) Interrupt ݎ10mSPʂl


// ******************************************************
extern	unsigned char	tim_10ms_ad;					// `^cf[^擾pPOrPʃ^C}[
extern	unsigned char	tim_10ms_sw;					// XCb`͗pPOrPʃ^C}[
extern	unsigned char	tim_10ms_sw1_length;			// XCb`PpԂPOrPʃ^C}[@|P
extern	unsigned char	tim_10ms_sw1_continue;			// XCb`PpAPOrPʃ^C}[@|P
extern	unsigned char	tim_10ms_sw2_length;			// XCb`QpԂPOrPʃ^C}[@|P
extern	unsigned char	tim_10ms_sw2_continue;			// XCb`QpAPOrPʃ^C}[@|P
extern	unsigned char	tim_1s_no_key_timeup;			// L[͂Ȃ̃^CAbvp
extern	unsigned char	tim_10ms_blink;					// \uNpPOrPʃ^C}[
extern	unsigned char	tim_10ms_nixie;					// jLV[\̃^C~OpPOrPʃ^C}[
extern	unsigned char	tim_10ms_infrared;				// ԊORfqpPOrPʃ^C}[
extern	unsigned char	tim_10ms_uart;					// t`qspPOrPʃ^C}[
extern	unsigned char	proc_no_key_timeup(unsigned char on);
